Attribute VB_Name = "modGeneralProcedures"
Option Explicit
'module also requires modAPI
Public lChkDirCount As Long
Public lDelDirCount As Long
Public lChkFileCount As Long
Public lDelFileCount As Long

Public Sub CopyAllFiles(FromDirectory As String, ToDirectory As String, Optional sFilter As String = "*.*", Optional bOverwriteExisting As Boolean = False, Optional lblReturnStatus As Label)
On Error GoTo ErrorHandler
Dim winFileInfo As WIN32_FIND_DATA
Dim winFileInfoEmpty As WIN32_FIND_DATA
Dim iFirstFileHandle As Long
Dim iNextFileHandle As Long
Dim lClose As Long
  If Not IsFolder(FromDirectory) Then MessageBox 0, "Unable to locate or access source directory '" & FromDirectory & "'" & vbNewLine & "Copy all files procedure failed.", App.ProductName & " [Copy All Files]", MB_ICONEXCLAMATION
  If Not IsFolder(ToDirectory) Then
    CreatePath ToDirectory
  End If
  iFirstFileHandle = FindFirstFile(FromDirectory & "*.*", winFileInfo)
  If iFirstFileHandle > 0 Then
    CopyAllFilesCallTo winFileInfo, FromDirectory, ToDirectory, sFilter, bOverwriteExisting, lblReturnStatus
    ' Now loop and find the rest of the files
    Do
      DoEvents
      winFileInfo = winFileInfoEmpty
      iNextFileHandle = FindNextFile(iFirstFileHandle, winFileInfo)
      If iNextFileHandle > 0 Then
        CopyAllFilesCallTo winFileInfo, FromDirectory, ToDirectory, sFilter, bOverwriteExisting, lblReturnStatus
      Else
        Exit Do
      End If
    Loop
  End If
  lClose = FindClose(iFirstFileHandle)
  Exit Sub
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.CopyAllFiles'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Sub
  End If
End Sub
Private Sub CopyAllFilesCallTo(winFileInfo As WIN32_FIND_DATA, FromDirectory As String, ToDirectory As String, Optional sFilter As String = "*.*", Optional bOverwriteExisting As Boolean = False, Optional lblReturnStatus As Label)
On Error GoTo ErrorHandler
Dim sFileName As String
  sFileName = CleanString(winFileInfo.cFileName)
    If winFileInfo.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY Then
      Exit Sub
    Else
      If LCase(sFileName) Like LCase(sFilter) Then
        If Not lblReturnStatus Is Nothing Then
          lblReturnStatus.Caption = "Copying file '" & LCase(sFileName) & "'"
          DoEvents
        End If
        CopyFile FromDirectory & sFileName, ToDirectory & LCase(sFileName), Not bOverwriteExisting
      End If
    End If
  Exit Sub
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.CopyAllFilesCallTo'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Sub
  End If
End Sub
Public Function FileCount(sDirectory As String, sFilter As String) As Long
On Error GoTo ErrorHandler
Dim winFileInfo As WIN32_FIND_DATA
Dim winFileInfoEmpty As WIN32_FIND_DATA
Dim sFileName As String
Dim iFirstFileHandle As Long
Dim iNextFileHandle As Long
Dim lClose As Long
Dim lFileCount As Long
  If lstrlen(sDirectory) > 4 Then
    If Not IsFolder(sDirectory) Then MessageBox 0, "Unable to locate or access directory '" & sDirectory & "'" & vbNewLine & "FileCount procedure failed.", App.ProductName & " [Count Files]", MB_ICONEXCLAMATION
  End If
    iFirstFileHandle = FindFirstFile(sDirectory & "*.*", winFileInfo)
    sFileName = CleanString(winFileInfo.cFileName)
    If iFirstFileHandle > 0 Then
      If winFileInfo.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY Then
        ' It's a directory
      Else
        If LCase(sFileName) Like LCase(sFilter) Then
          lFileCount = lFileCount + 1
        End If
      End If
      ' Now loop and find the rest of the files
      Do
        DoEvents
        winFileInfo = winFileInfoEmpty
        iNextFileHandle = FindNextFile(iFirstFileHandle, winFileInfo)
        sFileName = CleanString(winFileInfo.cFileName)
        If iNextFileHandle <> 0 Then
          If winFileInfo.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY Then
            ' It's a directory
          Else
            If LCase(sFileName) Like LCase(sFilter) Then
              lFileCount = lFileCount + 1
            End If
          End If
        Else
          Exit Do
        End If
      Loop
    End If
    lClose = FindClose(iFirstFileHandle)
    FileCount = lFileCount
  Exit Function
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.FileCount'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Function
  End If
End Function
Public Function CleanString(ByRef strString As String) As String
  CleanString = Trim$(Replace(strString, Chr(0), ""))
End Function
Public Function GetParentDirectory(Address As String) As String
On Error GoTo ErrorHandler
Dim intLen As Integer
Dim intLoop As Integer
Dim strChar As String
Dim ReturnVal As String
Dim bolAddChar As Boolean
  If lstrlen(Address) > 1 Then
    intLen = lstrlen(Address)
      For intLoop = intLen To 1 Step -1
        strChar = Mid(Address, intLoop, 1)
        If bolAddChar Then
          ReturnVal = strChar & ReturnVal
        Else
          If strChar = "\" Then
            strChar = ""
            bolAddChar = True
          End If
        End If
      Next
  End If
  IsFolder ReturnVal
  GetParentDirectory = ReturnVal
  Exit Function
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.GetParentDirectory'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Function
  End If
End Function
Public Sub SaveFile(sData As String, sFilePath As String, Optional sFileExtension As String = "txt")
On Error GoTo ErrorHandler
Dim FileNum As Integer
Dim iInstrPos As Integer
  iInstrPos = InStr(1, sFilePath, ".")
  If iInstrPos > 0 Then
    sFilePath = Left(sFilePath, iInstrPos - 1)
  End If
  sFileExtension = Replace(sFileExtension, ".", "")
  sFilePath = sFilePath & "." & sFileExtension
  If IsFile(sFilePath) Then
    Kill sFilePath
  End If
  FileNum = FreeFile
  CreatePath GetParentDirectory(sFilePath)
  Open sFilePath For Output As FileNum
  Print #FileNum, sData
  Close #FileNum
  Exit Sub
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.SaveFile'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Sub
  End If
End Sub
Public Function RenameFile(sDirectory As String, sFileName As String, Optional sNewName As String = "")
On Error GoTo ErrorHandler
Dim sExtension As String
Dim sParsedFileName As String
  If Right(sDirectory, 1) <> "\" Then sDirectory = sDirectory & "\"
  If InStr(1, sFileName, ".") Then
    sExtension = LCase(Right(sFileName, lstrlen(sFileName) - InStr(1, sFileName, ".")))
    sParsedFileName = Left(sFileName, InStr(1, sFileName, ".") - 1)
  Else
    sExtension = ".jpg"
    sParsedFileName = sFileName
  End If
  If lstrlen(sNewName) < 1 Then
    sNewName = InputBox("Please enter new file name:", "Rename file", sParsedFileName)
  End If
  If InStr(1, sNewName, ".") Then
    sNewName = Left(sNewName, InStr(1, sNewName, ".") - 1)
  End If
  Name sDirectory & sFileName As sFileName & sNewName & sExtension
  Exit Function
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.RenameFile'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Function
  End If
End Function
Public Function FileName(sFilePath As String) As String
On Error GoTo ErrorHandler
Dim sTemp As String
Dim sOut As String
Dim i As Integer
  sTemp = sFilePath
  If Right(sTemp, 1) = "\" Then sTemp = Left(sTemp, lstrlen(sTemp) - 1)
  For i = lstrlen(sTemp) To 1 Step -1
    If Mid(sTemp, i, 1) <> "\" Then
      sOut = Mid(sTemp, i, 1) & sOut
    Else
      Exit For
    End If
  Next
  FileName = sOut
  Exit Function
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.FileName'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Function
  End If
End Function
Public Function OpenFile(sFilePath As String) As Boolean
Dim winFileData As WIN32_FIND_DATA
Dim lngFileHandle As Long
Dim lngShellRet As Long
Dim strMsg As String
  lngFileHandle = FindFirstFile(sFilePath, winFileData)
  If lngFileHandle = INVALID_HANDLE_VALUE Then
    MessageBox 0, "Unable to locate file:" & vbNewLine & sFilePath, App.ProductName, MB_ICONHAND
  Else
    lngShellRet = ShellExecute(0, "open", sFilePath, vbNullString, "", SW_MAXIMIZE)
    Select Case lngShellRet
      Case ERROR_FILE_NOT_FOUND
        strMsg = "The specified file was not found."
      Case ERROR_PATH_NOT_FOUND
        strMsg = "The specified path was not found."
      Case ERROR_BAD_FORMAT
        strMsg = " The .EXE file is invalid (non-Win32 .EXE or error in .EXE image)."
      Case SE_ERR_ACCESSDENIED
        strMsg = "The operating system denied access to the specified file."
      Case SE_ERR_ASSOCINCOMPLETE
        strMsg = "The filename association is incomplete or invalid."
      Case SE_ERR_DDEBUSY
        strMsg = "The DDE transaction could not be completed because other DDE transactions were being processed."
      Case SE_ERR_DDEFAIL
        strMsg = "The DDE transaction failed."
      Case SE_ERR_DDETIMEOUT
        strMsg = "The DDE transaction could not be completed because the request timed out."
      Case SE_ERR_DLLNOTFOUND
        strMsg = "The specified dynamic-link library was not found."
      Case SE_ERR_FNF
        strMsg = "The specified file was not found."
      Case SE_ERR_NOASSOC
        strMsg = "There is no application associated with the given filename extension."
      Case SE_ERR_OOM
        strMsg = "There was not enough memory to complete the operation."
      Case SE_ERR_PNF
        strMsg = "The specified path was not found."
      Case SE_ERR_SHARE
        strMsg = "A sharing violation occurred."
      Case Is < 33
        strMsg = "Unknown Error # " & CStr(lngShellRet)
      Case Else
        strMsg = ""
    End Select
    If Len(strMsg) > 1 Then
      MessageBox 0, "Error Openning File" & vbNewLine & "Error # " & CStr(lngShellRet) & vbNewLine & strMsg, "Error Openning File", MB_ICONHAND
    End If
  End If
  FindClose lngFileHandle
  Exit Function
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.OpenFile'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Function
  End If
End Function
Public Function InIDE() As Boolean
On Error GoTo ErrorHandler
    On Error Resume Next
    Debug.Print 1 \ 0
    InIDE = Err.Number
  Exit Function
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.InIDE'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Function
  End If
End Function
Public Sub DeleteAllFiles2(sDirectory As String, Optional bAskFirst As Boolean = True)
On Error GoTo ErrorHandler
  If bAskFirst Then
    If MsgBox("Are you sure that you want to delete all files in directory '" & sDirectory & "'?", vbQuestion + vbYesNo, App.Title) = vbNo Then Exit Sub
  End If
  If Right(sDirectory, 1) <> "\" Then sDirectory = sDirectory & "\"
  Dim sFileName As String
    sFileName = Dir(sDirectory & "*.*", vbHidden + vbArchive + vbNormal + vbReadOnly)
    If lstrlen(sFileName) > 0 Then
      DeleteFile sDirectory & sFileName
      Do
        sFileName = Dir()
        If lstrlen(sFileName) > 0 Then
          DeleteFile sDirectory & sFileName
        Else
          Exit Sub
        End If
      Loop
    Else
      Exit Sub
    End If
  Exit Sub
ErrorHandler:
  If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.DeleteAllFiles'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
    Resume Next
  Else
    Exit Sub
  End If
End Sub
Public Sub DelAllFiles(ByVal sDirectory As String, _
  ByVal sFilter As String, ByVal bDeleteSubDirFiles As Boolean, _
  ByVal bDeleteSubDirectories As Boolean, bReportErrors As Boolean, _
  Optional lblStatus As Label, Optional lblAction As Label, Optional txtReport As TextBox)
On Error GoTo ErrorHandler
Dim winFileInfo As WIN32_FIND_DATA
Dim winFileInfoEmpty As WIN32_FIND_DATA
Dim iFirstFileHandle As Long
Dim iNextFileHandle As Long
Dim lClose As Long
  If Not IsFolder(sDirectory) Then
    MessageBox 0, "Unable to locate or access " _
      & "directory '" & sDirectory & "'" & vbNewLine & "Copy all files procedure failed.", _
      App.ProductName & " [Delete All Files]", MB_ICONEXCLAMATION
    Exit Sub
  End If
  If Not lblStatus Is Nothing Then lblStatus.Caption = "Searching: " & sDirectory
  lChkDirCount = lChkDirCount + 1
  If lstrlen(sFilter) < 1 Then sFilter = "*.*"
  iFirstFileHandle = FindFirstFile(sDirectory & "*.*", winFileInfo)
  If iFirstFileHandle > 0 Then
    DelAllFilesCallTo winFileInfo, sDirectory, sFilter, bDeleteSubDirFiles, bDeleteSubDirectories, bReportErrors, lblStatus, lblAction, txtReport
    Do
      DoEvents
      winFileInfo = winFileInfoEmpty
      iNextFileHandle = FindNextFile(iFirstFileHandle, winFileInfo)
      If iNextFileHandle > 0 Then
        DelAllFilesCallTo winFileInfo, sDirectory, sFilter, bDeleteSubDirFiles, bDeleteSubDirectories, bReportErrors, lblStatus, lblAction, txtReport
      Else
        Exit Do
      End If
    Loop
  End If
  lClose = FindClose(iFirstFileHandle)
  'If Not lblStatus Is Nothing Then lblStatus.Caption = ""
  Exit Sub
ErrorHandler:
  If bReportErrors Then
    If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.DelAllFiles'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
      Resume Next
    Else
      Exit Sub
    End If
  Else
    Resume Next
  End If
End Sub
Private Sub DelAllFilesCallTo(winFileInfo As WIN32_FIND_DATA, _
  ByVal sDirectory As String, ByVal sFilter As String, _
  ByVal bDeleteSubDirFiles As Boolean, ByVal bDeleteSubDirectories As Boolean, _
  ByVal bReportErrors As Boolean, Optional lblStatus As Label, Optional lblAction As Label, Optional txtReport As TextBox)
On Error GoTo ErrorHandler
Dim sFileName As String
Dim sFile As String
  sFileName = CleanString(winFileInfo.cFileName)
  sFile = sDirectory & IIf(Right(sDirectory, 1) = "\", "", "\") & sFileName
    If winFileInfo.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY Then
      If sFileName = "." Or sFileName = ".." Then
        Exit Sub
      Else
        If bDeleteSubDirFiles Then
          sDirectory = sFile & "\"
          DelAllFiles sDirectory, sFilter, bDeleteSubDirFiles, bDeleteSubDirectories, bReportErrors, lblStatus, lblAction, txtReport
          If bDeleteSubDirectories Then
            RmDir sFile
            lDelDirCount = lDelDirCount + 1
          End If
        End If
      End If
    Else
      lChkFileCount = lChkFileCount + 1
      If LCase(sFileName) Like LCase(sFilter) Then
        If Not lblAction Is Nothing Then lblAction.Caption = "Deleting: " & sFileName
        DoEvents
        If DeleteFile(sFile) Then
          lDelFileCount = lDelFileCount + 1
        End If
        DoEvents
      End If
    End If
    'lblAction.Caption = ""
    If Not txtReport Is Nothing Then txtReport.Text = "Run Time: " & CStr(Now()) & vbNewLine _
      & "Directories searched: " & CStr(lChkDirCount) & vbNewLine _
      & "Directories deleted: " & CStr(lDelDirCount) & vbNewLine _
      & "Files checked: " & CStr(lChkFileCount) & vbNewLine _
      & "Files deleted: " & CStr(lDelFileCount)
  Exit Sub
ErrorHandler:
  If bReportErrors Then
    If MessageBox(0, "Error " & CStr(Err.Number) & vbNewLine & Err.Description & vbNewLine & "Error in procedure 'modGeneralProcedures.DelAllFilesCallTo'. Do you wish to continue running this procedure?" & vbNewLine & "Yes = Resume Next" & vbNewLine & "No = Exit Function", "Error - " & App.ProductName, MB_ICONHAND Or MB_YESNO) = IDYES Then
      Resume Next
    Else
      Exit Sub
    End If
  Else
    Resume Next
  End If
End Sub
Public Function PathSlash(sPath As String) As String
  PathSlash = sPath & IIf(Right(sPath, 1) = "\", "", "\")
End Function
